Index: trunk/MagicSoft/Mars/manalysis/MSelBasic.cc
===================================================================
--- trunk/MagicSoft/Mars/manalysis/MSelBasic.cc	(revision 1885)
+++ trunk/MagicSoft/Mars/manalysis/MSelBasic.cc	(revision 1888)
@@ -61,6 +61,6 @@
     fTitle = title ? title : "Task to evaluate basic cuts";
 
-    ThetaMin =  0.0;
-    ThetaMax = 60.0;
+    fThetaMin =  0.0;
+    fThetaMax = 60.0;
 }
 
@@ -109,5 +109,5 @@
     }
 
-    memset(fErrors, 0, sizeof(fErrors));
+    memset(fCut, 0, sizeof(fCut));
 
     return kTRUE;
@@ -123,80 +123,4 @@
 Bool_t MSelBasic::Process()
 {
-  /*
-  //$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
-  *fLog << "=========================================================" << endl;
-  *fLog << "" << endl;
-  *fLog << "MmcEvt data : " << endl;
-  *fLog << "" << endl;
-  fMcEvt->Print();
-  *fLog << "" << endl;
-  *fLog << "PartId() = " << fMcEvt->GetPartId() << endl;
-  *fLog << "Energy() = " << fMcEvt->GetEnergy() << endl;
-  *fLog << "Theta()  = " << fMcEvt->GetTheta() << endl;
-
-  *fLog << "Phi()    = " << fMcEvt->GetPhi() << endl;
-  //*fLog << "CoreD()  = " << fMcEvt->GetCoreD() << endl;
-  //*fLog << "CoreX()  = " << fMcEvt->GetCoreX() << endl;
-
-  //*fLog << "CoreY()  = " << fMcEvt->GetCoreY() << endl;
-  *fLog << "Impact() = " << fMcEvt->GetImpact() << endl;
-  //*fLog << "PhotIni()= " << fMcEvt->GetPhotIni() << endl;
-
-  //*fLog << "PassPhotAtm() = " << fMcEvt->GetPassPhotAtm() << endl;
-  //*fLog << "PassPhotRef() = " << fMcEvt->GetPassPhotRef() << endl;
-  //*fLog << "PassPhotCone()  = " << fMcEvt->GetPassPhotCone() << endl;
-
-  //*fLog << "PhotElfromShower()    = " << fMcEvt->GetPhotElfromShower() << endl;
-  //*fLog << "PhotElinCamera()  = " << fMcEvt->GetPhotElinCamera() << endl;
-  *fLog << "TelescopePhi()  = " << fMcEvt->GetTelescopePhi() << endl;
-
-  *fLog << "TelescopeTheta()  = " << fMcEvt->GetTelescopeTheta() << endl;
-  *fLog << "Impact() = " << fMcEvt->GetImpact() << endl;
-  //*fLog << "PhotIni()= " << fMcEvt->GetPhotIni() << endl;
-  *fLog << "" << endl;
-  *fLog << "=========================================================" << endl;
-
-  *fLog << "=========================================================" << endl;
-  *fLog << "" << endl;
-  *fLog << "MPedestalPix data : " << endl;
-  *fLog << "" << endl;
-
-  Int_t ntot;
-  ntot = fPed->GetSize();
-    *fLog << "MeanRms() :" << endl;    
-  for (Int_t i=0; i<ntot; i++)
-  {
-    MPedestalPix &pix = (*fPed)[i];
-    //*fLog << "Mean()    = " << i << ",  " << pix.GetMean() << endl;    
-    //*fLog << "Sigma()   = " << i << ",  " << pix.GetSigma() << endl;    
-    *fLog << pix.GetMeanRms() << " ";    
-    //*fLog << "SigmaRms()= " << i << ",  " << pix.GetSigmaRms() << endl;    
-  }
-  *fLog << "" << endl;
-
-  *fLog << "" << endl;
-  ntot = fEvt->GetNumPixels();
-    *fLog << "MCerPhotPix :  pix.GetNumPhotons()" << endl;    
-  for (Int_t i=0; i<ntot; i++)
-  {
-    MCerPhotPix &pix = (*fEvt)[i];
-    *fLog << pix.GetNumPhotons() << " ";    
-  }
-  *fLog << "" << endl;
-
-  *fLog << "" << endl;
-  ntot = fEvt->GetNumPixels();
-    *fLog << "MCerPhotPix :  pix.GetErrorPhot()" << endl;    
-  for (Int_t i=0; i<ntot; i++)
-  {
-    MCerPhotPix &pix = (*fEvt)[i];
-    *fLog << pix.GetErrorPhot() << " ";    
-  }
-  *fLog << "" << endl;
-
-  //$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
-  */
-
-
     Int_t rc = 0;
 
@@ -207,14 +131,14 @@
     //}
 
-    Double_t Theta = kRad2Deg*fMcEvt->GetTelescopeTheta();
-    if ( Theta < ThetaMin )
+    Double_t theta = kRad2Deg*fMcEvt->GetTelescopeTheta();
+    if ( theta < fThetaMin )
     {
       *fLog << "MSelBasic::Process; Run, Event, Theta = " 
             << fRawRun->GetRunNumber()<< ",  " 
-            << fMcEvt->GetEvtNumber() << ",  " << Theta << endl;
+            << fMcEvt->GetEvtNumber() << ",  " << theta << endl;
       rc = 1;
     }    
 
-    else if ( Theta > ThetaMax )
+    else if ( theta > fThetaMax )
     {
       rc = 2;
@@ -227,5 +151,5 @@
     }    
 
-    fErrors[rc]++;
+    fCut[rc]++;
 
     return rc==0 ? kTRUE : kCONTINUE;
@@ -246,23 +170,4 @@
     const Int_t entries = fEvt->GetNumPixels();
  
-    //$$$$$$$$$$$$$$$$$$
-    //const Int_t nall = fPed->GetSize();  
-    //*fLog << "nall = " << nall << endl;
-    //for (Int_t id=0; id<nall; id++)
-    //{
-    //  MGeomPix &gpix = (*fCam)[id];
-    //  if ( gpix.IsInOutermostRing() ) 
-    //  {
-    //    *fLog << "IsInOutermostRing : pixel no. = " << id << endl;
-    //  }
-
-    //  if ( gpix.IsInOuterRing() ) 
-    //  {
-    //    *fLog << "IsInOuterRing : pixel no. = " << id << endl;
-    //  }
-    //}
-    //$$$$$$$$$$$$$$$$$$
-
-
     for (Int_t i=0; i<entries; i++)
     {
@@ -316,17 +221,17 @@
     *fLog << GetDescriptor() << " execution statistics:" << endl;
     *fLog << dec << setfill(' ');
-    *fLog << " " << setw(7) << fErrors[1] << " (" << setw(3) 
-          << (int)(fErrors[1]*100/GetNumExecutions()) 
-          << "%) Evts skipped due to: Zenith angle < " << ThetaMin << endl;
-
-    *fLog << " " << setw(7) << fErrors[2] << " (" << setw(3) 
-          << (int)(fErrors[2]*100/GetNumExecutions()) 
-          << "%) Evts skipped due to: Zenith angle > " << ThetaMax << endl;
-
-    *fLog << " " << setw(7) << fErrors[3] << " (" << setw(3) 
-          << (int)(fErrors[3]*100/GetNumExecutions()) 
+    *fLog << " " << setw(7) << fCut[1] << " (" << setw(3) 
+          << (int)(fCut[1]*100/GetNumExecutions()) 
+          << "%) Evts skipped due to: Zenith angle < " << fThetaMin << endl;
+
+    *fLog << " " << setw(7) << fCut[2] << " (" << setw(3) 
+          << (int)(fCut[2]*100/GetNumExecutions()) 
+          << "%) Evts skipped due to: Zenith angle > " << fThetaMax << endl;
+
+    *fLog << " " << setw(7) << fCut[3] << " (" << setw(3) 
+          << (int)(fCut[3]*100/GetNumExecutions()) 
           << "%) Evts skipped due to: Software trigger not fullfilled" << endl;
 
-    *fLog << " " << fErrors[0] << " (" << (int)(fErrors[0]*100/GetNumExecutions()) 
+    *fLog << " " << fCut[0] << " (" << (int)(fCut[0]*100/GetNumExecutions()) 
           << "%) Evts survived Basic selections!" << endl;
     *fLog << endl;
@@ -336,2 +241,9 @@
 
 
+
+
+
+
+
+
+